/*
Adott az n elemű (0 < n ≤ 10 000) a sorozat, amelynek elemei 30 000-nél kisebb szigorúan pozitív természetes számok. 
Írjunk programot, amely a sorozat minden eleme után beszúr egy új számot, amely 2-nek az a legnagyobb hatványa, 
amely kisebb vagy egyenlő az adott elem értékével. 
Példa: ha n = 4 és a = (3, 1, 24, 9), akkor az új a sorozat: (3, 2, 1, 1, 24, 16, 9, 8) és új n = 8.
*/

#include <iostream>
#include <fstream>

using namespace std;

const int maxDim = 20001;

ifstream f("be.in");

void beOlvas(int & n, int a[]){
// beolvassuk az adott sorozatot

	f >> n;
	for(int i = 0; i < n; i++)
		f >> a[i];	
}

void kiIr(int n, int a[]){
// kiírjuk az a sorozatot

	for(int i = 0; i < n; i++)
		cout << a[i] << " ";
	cout << endl;
}

void beszurHatvanyokat(int & n, int a[]){	
// segedadatszerkezet hasznalata nelkul, menet közben kiszámított 2_hatványokat szúrunk be

	int aux, hatvany;
	
   	for(int i = n - 1; i >= 0; i--){ // bejárjuk a sorozatot jobbról balra az n-1. és a 0. pozíció között 
      	a[2 * i] = a[i];			 // az adott elemet elhelyezzük a végsõ helyére, amelynek indexe 2*i 
      	aux = a[i];					 // elmentjük a[i]-t 
      	hatvany = 1;				 // aux-ban számoljuk ki azt a 2-hatványt, amit a[2*i+1]-be fogunk helyezni 
      	while(aux > 1) { 
         	aux = aux / 2;
         	hatvany = hatvany * 2;
      	}
      	a[2 * i + 1] = hatvany;		 // a 2*i+1. pozícióba helyezzük azt a legnagyobb 2-hatványt, amely kisebb  
   	}								 // vagy egyenlõ a[i]-vel
   	n = 2 * n;						 // az a sorozat új hossza 
}

int main(){
	
int n;
int a[maxDim];
	
	beOlvas(n, a);
	cout << "Az adott sorozat: " << endl;
	kiIr(n, a);
	beszurHatvanyokat(n, a);
	cout << "Az uj sorozat: " << endl;
	kiIr(n, a);
}
